Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.vecmath
Class Matrix4d

    java.lang.Object
      javax.vecmath.Matrix4d

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class Matrix4d

extends java.lang.Object
implements java.io.Serializable, java.lang.Cloneable

A double precision floating point 4 by 4 matrix. Primarily to support 3D rotations.

See Also:
  Serialized Form

Field Summary
`double` | `m00` The first element of the first row.
`double` | `m01` The second element of the first row.
`double` | `m02` The third element of the first row.
`double` | `m03` The fourth element of the first row.
`double` | `m10` The first element of the second row.
`double` | `m11` The second element of the second row.
`double` | `m12` The third element of the second row.
`double` | `m13` The fourth element of the second row.
`double` | `m20` The first element of the third row.
`double` | `m21` The second element of the third row.
`double` | `m22` The third element of the third row.
`double` | `m23` The fourth element of the third row.
`double` | `m30` The first element of the fourth row.
`double` | `m31` The second element of the fourth row.
`double` | `m32` The third element of the fourth row.
`double` | `m33` The fourth element of the fourth row.

Constructor Summary
`Matrix4d()` Constructs and initializes a Matrix4d to all zeros.
`Matrix4d(double[] v)` Constructs and initializes a Matrix4d from the specified 16 element array.
`Matrix4d(double m00, double m01, double m02, double m03, double m10, double m11, double m12, double m13, double m20, double m21, double m22, double m23, double m30, double m31, double m32, double m33)` Constructs and initializes a Matrix4d from the specified 16 values.
`Matrix4d(Matrix3d m1, Vector3d t1, double s)` Constructs and initializes a Matrix4f from the rotation matrix, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components of the matrix.
`Matrix4d(Matrix3f m1, Vector3d t1, double s)` Constructs and initializes a Matrix4d from the rotation matrix, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components of the matrix.
`Matrix4d(Matrix4d m1)` Constructs a new matrix with the same values as the Matrix4d parameter.
`Matrix4d(Matrix4f m1)` Constructs a new matrix with the same values as the Matrix4f parameter.
`Matrix4d(Quat4d q1, Vector3d t1, double s)` Constructs and initializes a Matrix4d from the quaternion, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.
`Matrix4d(Quat4f q1, Vector3d t1, double s)` Constructs and initializes a Matrix4d from the quaternion, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.

Method Summary
`void` | `add(double scalar)` Adds a scalar to each component of this matrix.
`void` | `add(double scalar, Matrix4d m1)` Adds a scalar to each component of the matrix m1 and places the result into this.
`void` | `add(Matrix4d m1)` Sets the value of this matrix to sum of itself and matrix m1.
`void` | `add(Matrix4d m1, Matrix4d m2)` Sets the value of this matrix to the matrix sum of matrices m1 and m2.
`java.lang.Object` | `clone()` Creates a new object of the same class as this object.
`double` | `determinant()` Computes the determinant of this matrix.
`boolean` | `epsilonEquals(Matrix4d m1, double epsilon)` Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false.
`boolean` | `epsilonEquals(Matrix4d m1, float epsilon)` Deprecated. Use epsilonEquals(Matrix4d,double) instead
`boolean` | `equals(Matrix4d m1)` Returns true if all of the data members of Matrix4d m1 are equal to the corresponding data members in this Matrix4d.
`boolean` | `equals(java.lang.Object t1)` Returns true if the Object t1 is of type Matrix4d and all of the data members of t1 are equal to the corresponding data members in this Matrix4d.
`void` | `get(Matrix3d m1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3d parameter.
`double` | `get(Matrix3d m1, Vector3d t1)` Performs an SVD normalization of this matrix to calculate the rotation as a 3x3 matrix, the translation, and the scale.
`void` | `get(Matrix3f m1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3f parameter.
`double` | `get(Matrix3f m1, Vector3d t1)` Performs an SVD normalization of this matrix to calculate the rotation as a 3x3 matrix, the translation, and the scale.
`void` | `get(Quat4d q1)` Performs an SVD normalization of q1 matrix in order to acquire the normalized rotational component; the values are placed into the Quat4d parameter.
`void` | `get(Quat4f q1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Quat4f parameter.
`void` | `get(Vector3d trans)` Retrieves the translational components of this matrix.
`void` | `getColumn(int column, double[] v)` Copies the matrix values in the specified column into the array parameter.
`void` | `getColumn(int column, Vector4d v)` Copies the matrix values in the specified column into the vector parameter.
`double` | `getElement(int row, int column)` Retrieves the value at the specified row and column of this matrix.
`void` | `getRotationScale(Matrix3d m1)` Gets the upper 3x3 values of this matrix and places them into the matrix m1.
`void` | `getRotationScale(Matrix3f m1)` Gets the upper 3x3 values of this matrix and places them into the matrix m1.
`void` | `getRow(int row, double[] v)` Copies the matrix values in the specified row into the array parameter.
`void` | `getRow(int row, Vector4d v)` Copies the matrix values in the specified row into the vector parameter.
`double` | `getScale()` Performs an SVD normalization of this matrix to calculate and return the uniform scale factor.
`int` | `hashCode()` Returns a hash code value based on the data values in this object.
`void` | `invert()` Inverts this matrix in place.
`void` | `invert(Matrix4d m1)` Sets the value of this matrix to the matrix inverse of the passed (user declared) matrix m1.
`void` | `mul(double scalar)` Multiplies each element of this matrix by a scalar.
`void` | `mul(double scalar, Matrix4d m1)` Multiplies each element of matrix m1 by a scalar and places the result into this.
`void` | `mul(Matrix4d m1)` Sets the value of this matrix to the result of multiplying itself with matrix m1.
`void` | `mul(Matrix4d m1, Matrix4d m2)` Sets the value of this matrix to the result of multiplying the two argument matrices together.
`void` | `mulTransposeBoth(Matrix4d m1, Matrix4d m2)` Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.
`void` | `mulTransposeLeft(Matrix4d m1, Matrix4d m2)` Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.
`void` | `mulTransposeRight(Matrix4d m1, Matrix4d m2)` Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.
`void` | `negate()` Negates the value of this matrix: this = -this.
`void` | `negate(Matrix4d m1)` Sets the value of this matrix equal to the negation of of the Matrix4d parameter.
`void` | `rotX(double angle)` Sets the value of this matrix to a counter-clockwise rotation about the x axis.
`void` | `rotY(double angle)` Sets the value of this matrix to a counter-clockwise rotation about the y axis.
`void` | `rotZ(double angle)` Sets the value of this matrix to a counter-clockwise rotation about the z axis.
`void` | `set(AxisAngle4d a1)` Sets the value of this matrix to the matrix conversion of the double precision axis and angle argument.
`void` | `set(AxisAngle4f a1)` Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.
`void` | `set(double scale)` Sets the value of this matrix to a scale matrix with the passed scale amount.
`void` | `set(double[] m)` Sets the values in this Matrix4d equal to the row-major array parameter (ie, the first four elements of the array will be copied into the first row of this matrix, etc.).
`void` | `set(double scale, Vector3d v1)` Sets the value of this transform to a scale and translation matrix; the scale is not applied to the translation and all of the matrix values are modified.
`void` | `set(Matrix3d m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are initialized as if this were an identity matrix (i.e., affine matrix with no translational component).
`void` | `set(Matrix3d m1, Vector3d t1, double scale)` Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale factor.
`void` | `set(Matrix3f m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are initialized as if this were an identity matrix (i.e., affine matrix with no translational component).
`void` | `set(Matrix3f m1, Vector3f t1, float scale)` Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale factor.
`void` | `set(Matrix4d m1)` Sets the value of this matrix to a copy of the passed matrix m1.
`void` | `set(Matrix4f m1)` Sets the value of this matrix to a copy of the passed matrix m1.
`void` | `set(Quat4d q1)` Sets the value of this matrix to the matrix conversion of the (double precision) quaternion argument.
`void` | `set(Quat4d q1, Vector3d t1, double s)` Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.
`void` | `set(Quat4f q1)` Sets the value of this matrix to the matrix conversion of the single precision quaternion argument.
`void` | `set(Quat4f q1, Vector3d t1, double s)` Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.
`void` | `set(Quat4f q1, Vector3f t1, float s)` Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.
`void` | `set(Vector3d v1)` Sets the value of this matrix to a translate matrix by the passed translation value.
`void` | `set(Vector3d v1, double scale)` Sets the value of this transform to a scale and translation matrix; the translation is scaled by the scale factor and all of the matrix values are modified.
`void` | `setColumn(int column, double[] v)` Sets the specified column of this matrix4d to the four values provided.
`void` | `setColumn(int column, double x, double y, double z, double w)` Sets the specified column of this matrix4d to the four values provided.
`void` | `setColumn(int column, Vector4d v)` Sets the specified column of this matrix4d to the vector provided.
`void` | `setElement(int row, int column, double value)` Sets the specified element of this matrix4f to the value provided.
`void` | `setIdentity()` Sets this Matrix4d to identity.
`void` | `setRotation(AxisAngle4d a1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the axis-angle argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the axis-angle, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Matrix3d m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Matrix3f m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Quat4d q1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Quat4f q1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.
`void` | `setRotationScale(Matrix3d m1)` Replaces the upper 3x3 matrix values of this matrix with the values in the matrix m1.
`void` | `setRotationScale(Matrix3f m1)` Replaces the upper 3x3 matrix values of this matrix with the values in the matrix m1.
`void` | `setRow(int row, double[] v)` Sets the specified row of this matrix4d to the four values provided.
`void` | `setRow(int row, double x, double y, double z, double w)` Sets the specified row of this matrix4d to the four values provided.
`void` | `setRow(int row, Vector4d v)` Sets the specified row of this matrix4d to the Vector provided.
`void` | `setScale(double scale)` Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) from the rotational component and multiplying by the new scale.
`void` | `setTranslation(Vector3d trans)` Modifies the translational components of this matrix to the values of the Vector3d argument; the other values of this matrix are not modified.
`void` | `setZero()` Sets this matrix to all zeros.
`void` | `sub(Matrix4d m1)` Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).
`void` | `sub(Matrix4d m1, Matrix4d m2)` Sets the value of this matrix to the matrix difference of matrices m1 and m2.
`java.lang.String` | `toString()` Returns a string that contains the values of this Matrix4d.
`void` | `transform(Point3d point)` Transforms the point parameter with this Matrix4d and places the result back into point.
`void` | `transform(Point3d point, Point3d pointOut)` Transforms the point parameter with this Matrix4d and places the result into pointOut.
`void` | `transform(Point3f point)` Transforms the point parameter with this Matrix4d and places the result back into point.
`void` | `transform(Point3f point, Point3f pointOut)` Transforms the point parameter with this Matrix4d and places the result into pointOut.
`void` | `transform(Tuple4d vec)` Transform the vector vec using this Matrix4d and place the result back into vec.
`void` | `transform(Tuple4d vec, Tuple4d vecOut)` Transform the vector vec using this Matrix4d and place the result into vecOut.
`void` | `transform(Tuple4f vec)` Transform the vector vec using this Transform and place the result back into vec.
`void` | `transform(Tuple4f vec, Tuple4f vecOut)` Transform the vector vec using this Matrix4d and place the result into vecOut.
`void` | `transform(Vector3d normal)` Transforms the normal parameter by this transform and places the value back into normal.
`void` | `transform(Vector3d normal, Vector3d normalOut)` Transforms the normal parameter by this Matrix4d and places the value into normalOut.
`void` | `transform(Vector3f normal)` Transforms the normal parameter by this transform and places the value back into normal.
`void` | `transform(Vector3f normal, Vector3f normalOut)` Transforms the normal parameter by this Matrix4d and places the value into normalOut.
`void` | `transpose()` Sets the value of this matrix to its transpose.
`void` | `transpose(Matrix4d m1)` Sets the value of this matrix to the transpose of the argument matrix

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### m00

    public double m00

  The first element of the first row.

### m01

    public double m01

  The second element of the first row.

### m02

    public double m02

  The third element of the first row.

### m03

    public double m03

  The fourth element of the first row.

### m10

    public double m10

  The first element of the second row.

### m11

    public double m11

  The second element of the second row.

### m12

    public double m12

  The third element of the second row.

### m13

    public double m13

  The fourth element of the second row.

### m20

    public double m20

  The first element of the third row.

### m21

    public double m21

  The second element of the third row.

### m22

    public double m22

  The third element of the third row.

### m23

    public double m23

  The fourth element of the third row.

### m30

    public double m30

  The first element of the fourth row.

### m31

    public double m31

  The second element of the fourth row.

### m32

    public double m32

  The third element of the fourth row.

### m33

    public double m33

  The fourth element of the fourth row.

Constructor Detail

### Matrix4d

    public Matrix4d(double m00,
                    double m01,
                    double m02,
                    double m03,
                    double m10,
                    double m11,
                    double m12,
                    double m13,
                    double m20,
                    double m21,
                    double m22,
                    double m23,
                    double m30,
                    double m31,
                    double m32,
                    double m33)

  Constructs and initializes a Matrix4d from the specified 16 values.

  Parameters:
    `m00` - the [0][0] element
    `m01` - the [0][1] element
    `m02` - the [0][2] element
    `m03` - the [0][3] element
    `m10` - the [1][0] element
    `m11` - the [1][1] element
    `m12` - the [1][2] element
    `m13` - the [1][3] element
    `m20` - the [2][0] element
    `m21` - the [2][1] element
    `m22` - the [2][2] element
    `m23` - the [2][3] element
    `m30` - the [3][0] element
    `m31` - the [3][1] element
    `m32` - the [3][2] element
    `m33` - the [3][3] element

### Matrix4d

    public Matrix4d(double[] v)

  Constructs and initializes a Matrix4d from the specified 16 element array. this.m00 =v[0], this.m01=v[1], etc.

  Parameters:
    `v` - the array of length 16 containing in order

### Matrix4d

    public Matrix4d(Quat4d q1,
                    Vector3d t1,
                    double s)

  Constructs and initializes a Matrix4d from the quaternion, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.

  Parameters:
    `q1` - the quaternion value representing the rotational component
    `t1` - the translational component of the matrix
    `s` - the scale value applied to the rotational components

### Matrix4d

    public Matrix4d(Quat4f q1,
                    Vector3d t1,
                    double s)

  Constructs and initializes a Matrix4d from the quaternion, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.

  Parameters:
    `q1` - the quaternion value representing the rotational component
    `t1` - the translational component of the matrix
    `s` - the scale value applied to the rotational components

### Matrix4d

    public Matrix4d(Matrix4d m1)

  Constructs a new matrix with the same values as the Matrix4d parameter.

  Parameters:
    `m1` - the source matrix

### Matrix4d

    public Matrix4d(Matrix4f m1)

  Constructs a new matrix with the same values as the Matrix4f parameter.

  Parameters:
    `m1` - the source matrix

### Matrix4d

    public Matrix4d(Matrix3f m1,
                    Vector3d t1,
                    double s)

  Constructs and initializes a Matrix4d from the rotation matrix, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components of the matrix.

  Parameters:
    `m1` - the rotation matrix representing the rotational components
    `t1` - the translational components of the matrix
    `s` - the scale value applied to the rotational components

### Matrix4d

    public Matrix4d(Matrix3d m1,
                    Vector3d t1,
                    double s)

  Constructs and initializes a Matrix4f from the rotation matrix, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components of the matrix.

  Parameters:
    `m1` - the rotation matrix representing the rotational components
    `t1` - the translational components of the matrix
    `s` - the scale value applied to the rotational components

### Matrix4d

    public Matrix4d()

  Constructs and initializes a Matrix4d to all zeros.

Method Detail

### toString

    public java.lang.String toString()

  Returns a string that contains the values of this Matrix4d.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the String representation

### setIdentity

    public final void setIdentity()

  Sets this Matrix4d to identity.

### setElement

    public final void setElement(int row,
                                 int column,
                                 double value)

  Sets the specified element of this matrix4f to the value provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `column` - the column number to be modified (zero indexed)
    `value` - the new value

### getElement

    public final double getElement(int row,
                                   int column)

  Retrieves the value at the specified row and column of this matrix.

  Parameters:
    `row` - the row number to be retrieved (zero indexed)
    `column` - the column number to be retrieved (zero indexed)
  Returns:
    the value at the indexed element

### getRow

    public final void getRow(int row,
                             Vector4d v)

  Copies the matrix values in the specified row into the vector parameter.

  Parameters:
    `row` - the matrix row
    `v` - the vector into which the matrix row values will be copied

### getRow

    public final void getRow(int row,
                             double[] v)

  Copies the matrix values in the specified row into the array parameter.

  Parameters:
    `row` - the matrix row
    `v` - the array into which the matrix row values will be copied

### getColumn

    public final void getColumn(int column,
                                Vector4d v)

  Copies the matrix values in the specified column into the vector parameter.

  Parameters:
    `column` - the matrix column
    `v` - the vector into which the matrix column values will be copied

### getColumn

    public final void getColumn(int column,
                                double[] v)

  Copies the matrix values in the specified column into the array parameter.

  Parameters:
    `column` - the matrix column
    `v` - the array into which the matrix column values will be copied

### get

    public final void get(Matrix3d m1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3d parameter.

  Parameters:
    `m1` - the matrix into which the rotational component is placed

### get

    public final void get(Matrix3f m1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3f parameter.

  Parameters:
    `m1` - the matrix into which the rotational component is placed

### get

    public final double get(Matrix3d m1,
                            Vector3d t1)

  Performs an SVD normalization of this matrix to calculate the rotation as a 3x3 matrix, the translation, and the scale. None of the matrix values are modified.

  Parameters:
    `m1` - the normalized matrix representing the rotation
    `t1` - the translation component
  Returns:
    the scale component of this transform

### get

    public final double get(Matrix3f m1,
                            Vector3d t1)

  Performs an SVD normalization of this matrix to calculate the rotation as a 3x3 matrix, the translation, and the scale. None of the matrix values are modified.

  Parameters:
    `m1` - the normalized matrix representing the rotation
    `t1` - the translation component
  Returns:
    the scale component of this transform

### get

    public final void get(Quat4f q1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Quat4f parameter.

  Parameters:
    `q1` - quaternion into which the rotation component is placed

### get

    public final void get(Quat4d q1)

  Performs an SVD normalization of q1 matrix in order to acquire the normalized rotational component; the values are placed into the Quat4d parameter.

  Parameters:
    `q1` - the quaternion into which the rotation component is placed

### get

    public final void get(Vector3d trans)

  Retrieves the translational components of this matrix.

  Parameters:
    `trans` - the vector that will receive the translational component

### getRotationScale

    public final void getRotationScale(Matrix3f m1)

  Gets the upper 3x3 values of this matrix and places them into the matrix m1.

  Parameters:
    `m1` - the matrix that will hold the values

### getRotationScale

    public final void getRotationScale(Matrix3d m1)

  Gets the upper 3x3 values of this matrix and places them into the matrix m1.

  Parameters:
    `m1` - the matrix that will hold the values

### getScale

    public final double getScale()

  Performs an SVD normalization of this matrix to calculate and return the uniform scale factor. If the matrix has non-uniform scale factors, the largest of the x, y, and z scale factors will be returned. This matrix is not modified.

  Returns:
    the scale factor of this matrix

### setRotationScale

    public final void setRotationScale(Matrix3d m1)

  Replaces the upper 3x3 matrix values of this matrix with the values in the matrix m1.

  Parameters:
    `m1` - the matrix that will be the new upper 3x3

### setRotationScale

    public final void setRotationScale(Matrix3f m1)

  Replaces the upper 3x3 matrix values of this matrix with the values in the matrix m1.

  Parameters:
    `m1` - the matrix that will be the new upper 3x3

### setScale

    public final void setScale(double scale)

  Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) from the rotational component and multiplying by the new scale.

  Parameters:
    `scale` - the new scale amount

### setRow

    public final void setRow(int row,
                             double x,
                             double y,
                             double z,
                             double w)

  Sets the specified row of this matrix4d to the four values provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `x` - the first column element
    `y` - the second column element
    `z` - the third column element
    `w` - the fourth column element

### setRow

    public final void setRow(int row,
                             Vector4d v)

  Sets the specified row of this matrix4d to the Vector provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `v` - the replacement row

### setRow

    public final void setRow(int row,
                             double[] v)

  Sets the specified row of this matrix4d to the four values provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `v` - the replacement row

### setColumn

    public final void setColumn(int column,
                                double x,
                                double y,
                                double z,
                                double w)

  Sets the specified column of this matrix4d to the four values provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `x` - the first row element
    `y` - the second row element
    `z` - the third row element
    `w` - the fourth row element

### setColumn

    public final void setColumn(int column,
                                Vector4d v)

  Sets the specified column of this matrix4d to the vector provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `v` - the replacement column

### setColumn

    public final void setColumn(int column,
                                double[] v)

  Sets the specified column of this matrix4d to the four values provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `v` - the replacement column

### add

    public final void add(double scalar)

  Adds a scalar to each component of this matrix.

  Parameters:
    `scalar` - the scalar adder

### add

    public final void add(double scalar,
                          Matrix4d m1)

  Adds a scalar to each component of the matrix m1 and places the result into this. Matrix m1 is not modified.

  Parameters:
    `scalar` - the scalar adder
    `m1` - the original matrix values

### add

    public final void add(Matrix4d m1,
                          Matrix4d m2)

  Sets the value of this matrix to the matrix sum of matrices m1 and m2.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### add

    public final void add(Matrix4d m1)

  Sets the value of this matrix to sum of itself and matrix m1.

  Parameters:
    `m1` - the other matrix

### sub

    public final void sub(Matrix4d m1,
                          Matrix4d m2)

  Sets the value of this matrix to the matrix difference of matrices m1 and m2.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### sub

    public final void sub(Matrix4d m1)

  Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).

  Parameters:
    `m1` - the other matrix

### transpose

    public final void transpose()

  Sets the value of this matrix to its transpose.

### transpose

    public final void transpose(Matrix4d m1)

  Sets the value of this matrix to the transpose of the argument matrix

  Parameters:
    `m1` - the matrix to be transposed

### set

    public final void set(double[] m)

  Sets the values in this Matrix4d equal to the row-major array parameter (ie, the first four elements of the array will be copied into the first row of this matrix, etc.).

  Parameters:
    `m` - the double precision array of length 16

### set

    public final void set(Matrix3f m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are initialized as if this were an identity matrix (i.e., affine matrix with no translational component).

  Parameters:
    `m1` - the double precision 3x3 matrix

### set

    public final void set(Matrix3d m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are initialized as if this were an identity matrix (i.e., affine matrix with no translational component).

  Parameters:
    `m1` - the double precision 3x3 matrix

### set

    public final void set(Quat4d q1)

  Sets the value of this matrix to the matrix conversion of the (double precision) quaternion argument.

  Parameters:
    `q1` - the quaternion to be converted

### set

    public final void set(AxisAngle4d a1)

  Sets the value of this matrix to the matrix conversion of the double precision axis and angle argument.

  Parameters:
    `a1` - the axis and angle to be converted

### set

    public final void set(Quat4f q1)

  Sets the value of this matrix to the matrix conversion of the single precision quaternion argument.

  Parameters:
    `q1` - the quaternion to be converted

### set

    public final void set(AxisAngle4f a1)

  Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.

  Parameters:
    `a1` - the axis and angle to be converted

### set

    public final void set(Quat4d q1,
                          Vector3d t1,
                          double s)

  Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.

  Parameters:
    `q1` - the rotation expressed as a quaternion
    `t1` - the translation
    `s` - the scale value

### set

    public final void set(Quat4f q1,
                          Vector3d t1,
                          double s)

  Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.

  Parameters:
    `q1` - the rotation expressed as a quaternion
    `t1` - the translation
    `s` - the scale value

### set

    public final void set(Quat4f q1,
                          Vector3f t1,
                          float s)

  Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.

  Parameters:
    `q1` - the rotation expressed as a quaternion
    `t1` - the translation
    `s` - the scale value

### set

    public final void set(Matrix4f m1)

  Sets the value of this matrix to a copy of the passed matrix m1.

  Parameters:
    `m1` - the matrix4f

### set

    public final void set(Matrix4d m1)

  Sets the value of this matrix to a copy of the passed matrix m1.

  Parameters:
    `m1` - the matrix to be copied

### invert

    public final void invert(Matrix4d m1)

  Sets the value of this matrix to the matrix inverse of the passed (user declared) matrix m1.

  Parameters:
    `m1` - the matrix to be inverted

### invert

    public final void invert()

  Inverts this matrix in place.

### determinant

    public final double determinant()

  Computes the determinant of this matrix.

  Returns:
    the determinant of the matrix

### set

    public final void set(double scale)

  Sets the value of this matrix to a scale matrix with the passed scale amount.

  Parameters:
    `scale` - the scale factor for the matrix

### set

    public final void set(Vector3d v1)

  Sets the value of this matrix to a translate matrix by the passed translation value.

  Parameters:
    `v1` - the translation amount

### set

    public final void set(double scale,
                          Vector3d v1)

  Sets the value of this transform to a scale and translation matrix; the scale is not applied to the translation and all of the matrix values are modified.

  Parameters:
    `scale` - the scale factor for the matrix
    `v1` - the translation amount

### set

    public final void set(Vector3d v1,
                          double scale)

  Sets the value of this transform to a scale and translation matrix; the translation is scaled by the scale factor and all of the matrix values are modified.

  Parameters:
    `v1` - the translation amount
    `scale` - the scale factor for the matrix

### set

    public final void set(Matrix3f m1,
                          Vector3f t1,
                          float scale)

  Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale factor. The translation is not modified by the scale.

  Parameters:
    `m1` - the rotation component
    `t1` - the translation component
    `scale` - the scale component

### set

    public final void set(Matrix3d m1,
                          Vector3d t1,
                          double scale)

  Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale factor. The translation is not modified by the scale.

  Parameters:
    `m1` - the rotation component
    `t1` - the translation component
    `scale` - the scale component

### setTranslation

    public final void setTranslation(Vector3d trans)

  Modifies the translational components of this matrix to the values of the Vector3d argument; the other values of this matrix are not modified.

  Parameters:
    `trans` - the translational component

### rotX

    public final void rotX(double angle)

  Sets the value of this matrix to a counter-clockwise rotation about the x axis.

  Parameters:
    `angle` - the angle to rotate about the X axis in radians

### rotY

    public final void rotY(double angle)

  Sets the value of this matrix to a counter-clockwise rotation about the y axis.

  Parameters:
    `angle` - the angle to rotate about the Y axis in radians

### rotZ

    public final void rotZ(double angle)

  Sets the value of this matrix to a counter-clockwise rotation about the z axis.

  Parameters:
    `angle` - the angle to rotate about the Z axis in radians

### mul

    public final void mul(double scalar)

  Multiplies each element of this matrix by a scalar.

  Parameters:
    `scalar` - the scalar multiplier.

### mul

    public final void mul(double scalar,
                          Matrix4d m1)

  Multiplies each element of matrix m1 by a scalar and places the result into this. Matrix m1 is not modified.

  Parameters:
    `scalar` - the scalar multiplier
    `m1` - the original matrix

### mul

    public final void mul(Matrix4d m1)

  Sets the value of this matrix to the result of multiplying itself with matrix m1.

  Parameters:
    `m1` - the other matrix

### mul

    public final void mul(Matrix4d m1,
                          Matrix4d m2)

  Sets the value of this matrix to the result of multiplying the two argument matrices together.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### mulTransposeBoth

    public final void mulTransposeBoth(Matrix4d m1,
                                       Matrix4d m2)

  Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.

  Parameters:
    `m1` - the matrix on the left hand side of the multiplication
    `m2` - the matrix on the right hand side of the multiplication

### mulTransposeRight

    public final void mulTransposeRight(Matrix4d m1,
                                        Matrix4d m2)

  Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.

  Parameters:
    `m1` - the matrix on the left hand side of the multiplication
    `m2` - the matrix on the right hand side of the multiplication

### mulTransposeLeft

    public final void mulTransposeLeft(Matrix4d m1,
                                       Matrix4d m2)

  Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.

  Parameters:
    `m1` - the matrix on the left hand side of the multiplication
    `m2` - the matrix on the right hand side of the multiplication

### equals

    public boolean equals(Matrix4d m1)

  Returns true if all of the data members of Matrix4d m1 are equal to the corresponding data members in this Matrix4d.

  Parameters:
    `m1` - the matrix with which the comparison is made
  Returns:
    true or false

### equals

    public boolean equals(java.lang.Object t1)

  Returns true if the Object t1 is of type Matrix4d and all of the data members of t1 are equal to the corresponding data members in this Matrix4d.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `t1` - the matrix with which the comparison is made
  Returns:
    true or false

### epsilonEquals

    public boolean epsilonEquals(Matrix4d m1,
                                 float epsilon)

  Deprecated. Use epsilonEquals(Matrix4d,double) instead

### epsilonEquals

    public boolean epsilonEquals(Matrix4d m1,
                                 double epsilon)

  Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false. The L-infinite distance is equal to MAX[i=0,1,2,3 ; j=0,1,2,3 ; abs(this.m(i,j) - m1.m(i,j)]

  Parameters:
    `m1` - the matrix to be compared to this matrix
    `epsilon` - the threshold value

### hashCode

    public int hashCode()

  Returns a hash code value based on the data values in this object. Two different Matrix4d objects with identical data values (i.e., Matrix4d.equals returns true) will return the same hash code value. Two objects with different data members may return the same hash value, although this is not likely.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    the integer hash code value

### transform

    public final void transform(Tuple4d vec,
                                Tuple4d vecOut)

  Transform the vector vec using this Matrix4d and place the result into vecOut.

  Parameters:
    `vec` - the double precision vector to be transformed
    `vecOut` - the vector into which the transformed values are placed

### transform

    public final void transform(Tuple4d vec)

  Transform the vector vec using this Matrix4d and place the result back into vec.

  Parameters:
    `vec` - the double precision vector to be transformed

### transform

    public final void transform(Tuple4f vec,
                                Tuple4f vecOut)

  Transform the vector vec using this Matrix4d and place the result into vecOut.

  Parameters:
    `vec` - the single precision vector to be transformed
    `vecOut` - the vector into which the transformed values are placed

### transform

    public final void transform(Tuple4f vec)

  Transform the vector vec using this Transform and place the result back into vec.

  Parameters:
    `vec` - the single precision vector to be transformed

### transform

    public final void transform(Point3d point,
                                Point3d pointOut)

  Transforms the point parameter with this Matrix4d and places the result into pointOut. The fourth element of the point input parameter is assumed to be one.

  Parameters:
    `point` - the input point to be transformed.
    `pointOut` - the transformed point

### transform

    public final void transform(Point3d point)

  Transforms the point parameter with this Matrix4d and places the result back into point. The fourth element of the point input parameter is assumed to be one.

  Parameters:
    `point` - the input point to be transformed.

### transform

    public final void transform(Point3f point,
                                Point3f pointOut)

  Transforms the point parameter with this Matrix4d and places the result into pointOut. The fourth element of the point input parameter is assumed to be one.

  Parameters:
    `point` - the input point to be transformed.
    `pointOut` - the transformed point

### transform

    public final void transform(Point3f point)

  Transforms the point parameter with this Matrix4d and places the result back into point. The fourth element of the point input parameter is assumed to be one.

  Parameters:
    `point` - the input point to be transformed.

### transform

    public final void transform(Vector3d normal,
                                Vector3d normalOut)

  Transforms the normal parameter by this Matrix4d and places the value into normalOut. The fourth element of the normal is assumed to be zero.

  Parameters:
    `normal` - the input normal to be transformed.
    `normalOut` - the transformed normal

### transform

    public final void transform(Vector3d normal)

  Transforms the normal parameter by this transform and places the value back into normal. The fourth element of the normal is assumed to be zero.

  Parameters:
    `normal` - the input normal to be transformed.

### transform

    public final void transform(Vector3f normal,
                                Vector3f normalOut)

  Transforms the normal parameter by this Matrix4d and places the value into normalOut. The fourth element of the normal is assumed to be zero.

  Parameters:
    `normal` - the input normal to be transformed.
    `normalOut` - the transformed normal

### transform

    public final void transform(Vector3f normal)

  Transforms the normal parameter by this transform and places the value back into normal. The fourth element of the normal is assumed to be zero.

  Parameters:
    `normal` - the input normal to be transformed.

### setRotation

    public final void setRotation(Matrix3d m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.

  Parameters:
    `m1` - double precision 3x3 matrix

### setRotation

    public final void setRotation(Matrix3f m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.

  Parameters:
    `m1` - single precision 3x3 matrix

### setRotation

    public final void setRotation(Quat4f q1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.

  Parameters:
    `q1` - the quaternion that specifies the rotation

### setRotation

    public final void setRotation(Quat4d q1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.

  Parameters:
    `q1` - the quaternion that specifies the rotation

### setRotation

    public final void setRotation(AxisAngle4d a1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the axis-angle argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the axis-angle, and then the scale is reapplied to the rotational components.

  Parameters:
    `a1` - the axis-angle to be converted (x, y, z, angle)

### setZero

    public final void setZero()

  Sets this matrix to all zeros.

### negate

    public final void negate()

  Negates the value of this matrix: this = -this.

### negate

    public final void negate(Matrix4d m1)

  Sets the value of this matrix equal to the negation of of the Matrix4d parameter.

  Parameters:
    `m1` - the source matrix

### clone

    public java.lang.Object clone()

  Creates a new object of the same class as this object.

  Overrides:
    `clone` in class `java.lang.Object`
  Returns:
    a clone of this instance.
  Throws:
    `java.lang.OutOfMemoryError` - if there is not enough memory.
  Since:
    Java 3D 1.3
  See Also:
    `Cloneable`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD